module Panda.View.Control.Post where

-- env
import Panda.Helper.Env
import Prelude hiding ((.), (/), (^), id, span)

import qualified Panda.Type.State as State
import qualified Panda.Config.Global as G

-- model
import qualified Panda.Model.Comment as Comment
import Panda.View.Atom.Post
import Panda.Model.Post

-- view
import Panda.View.Control.Helper
import qualified Panda.View.Control.Comment as CommentV
import Panda.View.Widget.Template

-- entry view
view state xs x = (x.render_data +++ CommentV.list xs +++ CommentV.create (x.uid.Comment.from_post_id) ).page state

-- list view
list state = for_current_page p >>> map render_data >>> (+++ nav p G.root) >>> page state
  where p = state.State.pager
